# Source: toresultbar.h

Annotated List
Files
Globals
Hierarchy
Index

    //***************************************************************************
    /*
     * TOra - An Oracle Toolkit for DBA's and developers
     * Copyright (C) 2000-2001,2001 Underscore AB
     *
     * This program is free software; you can redistribute it and/or
     * modify it under the terms of the GNU General Public License
     * as published by the Free Software Foundation;  only version 2 of
     * the License is valid for this program.
     *
     * This program is distributed in the hope that it will be useful,
     * but WITHOUT ANY WARRANTY; without even the implied warranty of
     * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     * GNU General Public License for more details.
     *
     * You should have received a copy of the GNU General Public License
     * along with this program; if not, write to the Free Software
     * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
     *
     *      As a special exception, you have permission to link this program
     *      with the Oracle Client libraries and distribute executables, as long
     *      as you follow the requirements of the GNU GPL in regard to all of the
     *      software in the executable aside from Oracle client libraries.
     *
     *      Specifically you are not permitted to link this program with the
     *      Qt/UNIX, Qt/Windows or Qt Non Commercial products of TrollTech.
     *      And you are not permitted to distribute binaries compiled against
     *      these libraries without written consent from Underscore AB. Observe
     *      that this does not disallow linking to the Qt Free Edition.
     *
     * All trademarks belong to their respective owners.
     *
     ****************************************************************************/

    #ifndef __TORESULTBAR_H
    #define __TORESULTBAR_H

    #include <time.h>

    #include <list>

    #include "toresult.h"
    #include "tobarchart.h"
    #include "tobackground.h"

    class toSQL;
    class toNoBlockQuery;

    /** Display the result of a query in a piechart. The first column of the query should
     * contain the x value and the rest of the columns should be values of the diagram. The
     * legend is the column name. Connects to the tool timer for updates automatically.
     */

    class toResultBar : public toBarChart, public toResult {
      Q_OBJECT
      /** Display flow in change per second instead of actual values.
       */
      bool Flow;
      /** Timestamp of last fetch.
       */
      time_t LastStamp;
      /** Last read values.
       */
      std::list<double> LastValues;
      bool First;
      toNoBlockQuery *Query;
      toBackground Poll;
      unsigned int Columns;
      void query(const QString &sql,const toQList ¶m,bool first);
    public:
      /** Create widget.
       * @param parent Parent of list.
       * @param name Name of widget.
       */
      toResultBar(QWidget *parent,const char *name=NULL);

      /** Destroy chart
       */
      ~toResultBar();

      /** Display actual values or flow/s.
       * @param on Display flow or absolute values.
       */
      void setFlow(bool on)
      { Flow=on; }
      /** Return if flow is displayed.
       * @return If flow is used.
       */
      bool flow(void)
      { return Flow; }

      /** Reimplemented for internal reasons.
       */
      virtual void query(const QString &sql,const toQList ¶m)
      { query(sql,param,true); }
      /** Reimplemented for internal reasons.
       */
      virtual void clear(void)
      { LastStamp=0; LastValues.clear(); toBarChart::clear(); }
      /** Transform valueset. Make it possible to perform more complex transformation.
       * called directly before adding the valueset to the chart. After flow transformation.
       * Default is passthrough.
       * @param input The untransformed valueset.
       * @return The valueset actually added to the chart.
       */
      virtual std::list<double> transform(std::list<double> &input);
      /** Handle any connection
       */
      virtual bool canHandle(toConnection &)
      { return true; }

      // Why are these needed?
    #if 1
      /** Set the SQL statement of this list
       * @param sql String containing statement.
       */
      void setSQL(const QString &sql)
      { toResult::setSQL(sql); }
      /** Set the SQL statement of this list. This will also affect @ref Name.
       * @param sql SQL containing statement.
       */
      void setSQL(toSQL &sql)
      { toResult::setSQL(sql); }
      /** Set new SQL and run query.
       * @param sql New sql.
       * @see setSQL
       */
      void query(const QString &sql)
      { toResult::query(sql); }
      /** Set new SQL and run query.
       * @param sql New sql.
       * @see setSQL
       */
      void query(toSQL &sql)
      { toResult::query(sql); }
    #endif
    public slots:
      /** Reimplemented for internal reasons.
       */
      virtual void refresh(void)
      { query(sql(),params(),false); }
      /** Reimplemented for internal reasons.
       */
      virtual void changeParams(const QString &Param1)
      { toResult::changeParams(Param1); }
      /** Reimplemented For internal reasons.
       */
      virtual void changeParams(const QString &Param1,const QString &Param2)
      { toResult::changeParams(Param1,Param2); }
      /** Reimplemented for internal reasons.
       */
      virtual void changeParams(const QString &Param1,const QString &Param2,const QString &Param3)
      { toResult::changeParams(Param1,Param2,Param3); }
    protected slots:
      /** Reimplemented for internal reasons.
       */
      virtual void connectionChanged(void);
    private slots:
      void poll(void);
    };

    #endif